#!/bin/sh
#
# file: $JEIDA/src/count_files/v1.0/src/count_files.sh
#
# this shellscript counts files
#
#  count_files.sh args
#
# usually, it is run using:
#
#  count_files.sh $JEIDA/val_data/4_digits/?????
#

# loop over all arguments
#
for arg do

    # echo the speaker
    #
    echo SPEAKER $arg":"

    # check the val files
    #
    NUM_FILES=`ls $arg/*_r1.val | wc | awk '{print $1}'`;
    echo " number of r1.val = $NUM_FILES";

    NUM_FILES=`ls $arg/*_r2.val | wc | awk '{print $1}'`;
    echo " number of r2.val = $NUM_FILES";

    NUM_FILES=`ls $arg/*_r3.val | wc | awk '{print $1}'`;
    echo " number of r3.val = $NUM_FILES";

    NUM_FILES=`ls $arg/*r4.val | wc | awk '{print $1}'`;
    echo " number of r4.val = $NUM_FILES";

    NUM_FILES=`ls $arg/*.val | wc | awk '{print $1}'`;
    echo " number of val files = $NUM_FILES";

    echo;

    # check r0 files
    #
    NUM_FILES=`ls $arg/*_r1_c0.raw | wc | awk '{print $1}'`;
    echo " number of r1_c0 = $NUM_FILES";

    NUM_FILES=`ls $arg/*_r2_c0.raw | wc | awk '{print $1}'`;
    echo " number of r2_c0 = $NUM_FILES";

    NUM_FILES=`ls $arg/*_r3_c0.raw | wc | awk '{print $1}'`;
    echo " number of r3_c0 = $NUM_FILES";

    NUM_FILES=`ls $arg/*r4_c0.raw | wc | awk '{print $1}'`;
    echo " number of r4_c0 = $NUM_FILES";

    NUM_FILES=`ls $arg/*c0.raw | wc | awk '{print $1}'`;
    echo " total number of c0.raw files = $NUM_FILES";

    echo;

    # check c1 files
    #
    NUM_FILES=`ls $arg/*_r1_c1.raw | wc | awk '{print $1}'`;
    echo " number of r1_c1 = $NUM_FILES";

    NUM_FILES=`ls $arg/*_r2_c1.raw | wc | awk '{print $1}'`;
    echo " number of r2_c1 = $NUM_FILES";

    NUM_FILES=`ls $arg/*_r3_c1.raw | wc | awk '{print $1}'`;
    echo " number of r3_c1 = $NUM_FILES";

    NUM_FILES=`ls $arg/*r4_c1.raw | wc | awk '{print $1}'`;
    echo " number of r4_c1 = $NUM_FILES";

    NUM_FILES=`ls $arg/*c1.raw | wc | awk '{print $1}'`;
    echo " total number of c1.raw files = $NUM_FILES";

    echo;

done

# exit gracefully
#
exit 0
