// get_command_line.cc

// system include files

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


// isip include files

#include <math/integral/integral.h>
#include <math/integral/integral_constants.h>

// local include files

#include "make_files.h"

short int get_command_line(int argc, char **argv, char *param_file_name, 
			   char *output_dir, char *base_name, char *prefix, 
			   char *extension, char *audio_file_name, 
			   char *endpointer_data_name)
{
  int index, maxium;

  if(argc < 2) 
    {
      return(ISIP_FALSE);
    }

  // get audio file name

  strcpy((char *)audio_file_name, argv[argc-1]);

  maxium = argc - 1;

  // get the rest of the command line
  
  for(index=1; index <= maxium; index++)
    {
      if(strcmp(ISIP_OPT_EXT, argv[index]) == 0)
	{
	  strcpy((char *)extension, argv[index+1]);
	}
      if(strcmp(ISIP_OPT_BASE, argv[index]) == 0)
	{
	  strcpy((char *)base_name, argv[index+1]);
	}
      if(strcmp(ISIP_OPT_PREFIX, argv[index]) == 0) 
	{
	  strcpy((char *)prefix, argv[index+1]);
	}
      if(strcmp(ISIP_OPT_OUTPUTDIR, argv[index]) == 0)
	{
	  strcpy((char *)output_dir, argv[index+1]);
	}
      if(strcmp(ISIP_OPT_PARAM, argv[index]) == 0)
	{
	  strcpy((char *)param_file_name, argv[index+1]);
	}
      if(strcmp(ISIP_OPT_END, argv[index]) == 0)
	{
	  strcpy((char *)endpointer_data_name, argv[index+1]);
	}
      if(strcmp(ISIP_OPT_HELP, argv[index]) == 0)
	{
	  printf("\nHelp.\n");
	  printf("%s\t\tExtension to use on output file(s).\n", ISIP_OPT_EXT);
	  printf("%s\t\tBase name to use on output file(s).\n", ISIP_OPT_BASE);
	  printf("%s\t\tPrefix to use on output file(s).\n", ISIP_OPT_PREFIX);
	  printf("%s\t\tOutput directory to place output file(s) in.\n", 
		 ISIP_OPT_OUTPUTDIR);
	  printf("%s\t\tParameter file to read audio parameters from.\n", 
		 ISIP_OPT_PARAM);
	  printf("%s\t\tFile containing endpoint(s) data.\n", ISIP_OPT_END);
	  printf("%s\t\tHelp for the masses.\n\n", ISIP_OPT_HELP);
	  return(ISIP_FALSE);
	}
    }

  return(ISIP_TRUE);
}



