
// use:
// endpointer parameter_file input_file source_file

#include "endpointer.h"

// main program code


float get_parameters(char *, FILE *);
float endpoint_calculator(FILE *, FILE *, struct parameter_data *parameter_ptr);

main(int argc, char *argv[]) 
{
  struct parameter_data *parameters_ptr;

  FILE *parameter_file, *source_file, *output_file;


// check command line arguments

  if (argc != 4)
    {
      fprintf(stderr, "Usage: endpointer [parameter file] [input file] [output file]\n");
      exit(1);
    }

  parameter_file = fopen(argv[1],"rt");
  if (parameter_file == NULL)
    {
      fprintf(stderr, "Error opening parameter file '%s'\n",argv[1]);
      exit(1);
    }

  source_file = fopen(argv[2],"rt");
  if (source_file == NULL)
    {
      fprintf(stderr, "Error opening source file '%s'\n",argv[2]);
      exit(1);
    }

  output_file = fopen(argv[3],"wt");
  if (output_file == NULL)
    {
      fprintf(stderr, "Error opening parameter file '%s'\n",argv[3]);
      exit(1);
    }
  

  parameters_ptr = (struct parameter_data *)malloc(sizeof (struct parameter_data)); 



  parameters_ptr->number_of_channels = get_parameters("number_of_channels", parameter_file);
  parameters_ptr->sample_type = get_parameters("sample_type", parameter_file); 
  parameters_ptr->channel_to_be_processed = get_parameters("channel_to_be_processed", parameter_file);
  parameters_ptr->sample_frequency = get_parameters("sample_frequency", parameter_file);
  parameters_ptr->frame_duration = get_parameters("frame_duration", parameter_file);
  parameters_ptr->nominal_noise_level = get_parameters("nominal_noise_level", parameter_file);
  parameters_ptr->nominal_signal_level = get_parameters("nominal_signal_level", parameter_file);
  parameters_ptr->noise_floor = get_parameters("noise_floor",parameter_file);
  parameters_ptr->noise_adaptation_constant = get_parameters("noise_adaptation_constant", parameter_file);
  parameters_ptr->signal_adaptation_constant = get_parameters("signal_adaptation_constant", parameter_file);
  parameters_ptr->noise_adaptation_delta = get_parameters("noise_adaptation_delta", parameter_file);
 parameters_ptr->signal_adaptation_delta = get_parameters("signal_adaptation_delta", parameter_file);
  parameters_ptr->utterance_delta = get_parameters("utterance_delta", parameter_file);
  parameters_ptr->minimum_utterance_duration = get_parameters("minimum_utterance_duration", parameter_file);
  parameters_ptr->minimum_utterance_separation = get_parameters("minimum_utterance_separation", parameter_file);
  parameters_ptr->debug_level = (int)get_parameters("debug_level", parameter_file);
  parameters_ptr->nominal_noise_constant = get_parameters("nominal_noise_constant",parameter_file);
  parameters_ptr->nominal_signal_constant = get_parameters("nominal_signal_constant", parameter_file);
  parameters_ptr->initial_padtime = get_parameters("startpoint_padtime", parameter_file);

  parameters_ptr->final_padtime = get_parameters("endpoint_padtime",parameter_file);


  // now that we've read in the data from the parameter file, close it.
  
  fclose(parameter_file);
  
  
  // Now entering the PaulZone
  
  
  endpoint_calculator(source_file,output_file,parameters_ptr);
  
  
  // Now leaving the PaulZone  VROOOooommmmm...
  
  
  
  
  
  // clean up and exit

  fclose(output_file);
  fclose(source_file);
  
  return(0);
  
}
