// file:  energy_2.cc

#include "endpointer.h"

// external function prototypes

float debiased_energy(short int *, int);
void histogram(float *, int, float, struct parameter_data *); 


// main function

void energy_2(FILE *source_file, int file_length, float *energy_array, int size_of_energy_array, struct parameter_data *parameter)
{
  
  // variable declarations

  int samples_in_frame;
  int counter;
  int frame_number = 0;
  float *energy_array_pointer;
  float max_energy = 0;
  short int *frame_buffer, *frame_buffer_pointer, *all_channels, *all_channels_pointer;


//  printf("size of energy_array is :%d\n", size_of_energy_array);


  // initialize some values

  samples_in_frame = (int)(parameter->frame_duration*parameter->sample_frequency);
  energy_array_pointer = energy_array;
  
//  printf("samples_in_frame = %d\n",samples_in_frame);
//  printf("sizeof(float) = %d\n", sizeof(float));

  // allocate space for arrays

  all_channels = (short int *)malloc(SAMPLE_SIZE*samples_in_frame*(int)parameter->number_of_channels);
  all_channels_pointer = all_channels;

  frame_buffer = (short int *)malloc(SAMPLE_SIZE*samples_in_frame);
  frame_buffer_pointer = frame_buffer;

  
  // main file reading loop

  rewind(source_file);
  while (fread(all_channels, samples_in_frame*(int)parameter->number_of_channels, SAMPLE_SIZE, source_file) > 0)
  {

/*
// debugging stuff - prints out all samples read from disk
   counter = 0;
   all_channels_pointer = all_channels;
   while(counter < parameter->number_of_channels * samples_in_frame)
   {
   printf("%d %d\n", counter, *all_channels_pointer);
   counter ++;
   all_channels_pointer ++;
   }
// end of debugging stuff
*/

// find the channel that we are interested in in all_channels and copy it
// to frame_buffer.

    frame_buffer_pointer = frame_buffer;
    all_channels_pointer = all_channels;
    counter = 0;
    while (counter < samples_in_frame)
      { 
	frame_buffer_pointer += (int)parameter->channel_to_be_processed;
	*frame_buffer_pointer = *all_channels_pointer;
	frame_buffer_pointer ++;
	all_channels_pointer += (int)parameter->number_of_channels;
	counter ++;
      }


/*      
// debugging stuff - prints out the channel of interest.
      counter = 0;
      frame_buffer_pointer = frame_buffer;
      while(counter < samples_in_frame)
	{
	  printf("%d %d\n", counter, *frame_buffer_pointer);
	  counter ++;
	  frame_buffer_pointer ++;
	}

// end of debugging stuff
*/

// debias the energy array.

    *energy_array_pointer =  debiased_energy(frame_buffer, samples_in_frame);
//  printf("%d %5.2f\n",frame_number, *energy_array_pointer);
    energy_array_pointer ++;
    frame_number ++;

  }

// find max energy value
  
  counter = 0;
  energy_array_pointer = energy_array;
  while (counter < frame_number)
    {
      if (*energy_array_pointer > max_energy)
	max_energy = *energy_array_pointer;
      counter ++;
      energy_array_pointer ++;
    }
//  printf("max energy value is :%5.2f\n",max_energy);

//  normalize energy

  counter = 0;
  energy_array_pointer = energy_array;
  while (counter < frame_number)
    {
      *energy_array_pointer -= max_energy;
//     printf("%d %5.2f\n",counter, *energy_array_pointer);
      counter ++;
      energy_array_pointer ++;
    }

// generate histogram
 
  histogram(energy_array, size_of_energy_array, max_energy, parameter);

  return;
}





























