
#ifndef __ISIP_PROGRAM
#define __ISIP_PROGRAM
#endif

#ifndef MAX_LINE_LENGTH
#define MAX_LINE_LENGTH 80
#endif

#ifndef DEFAULT_PARAM_FILE
#define DEFAULT_PARAM_FILE "endpointer_00.params" 
#endif

#ifndef DEFAULT_OUTPUT_FILE
#define DEFAULT_OUTPUT_FILE "endpoints.dat"
#endif

#ifndef SAMPLE_SIZE
#define SAMPLE_SIZE 2   /* 2 bytes */
#endif

#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE 1
#endif

// Define a scale factor for sample values
//
#define SAMPLE_SCALE_FACTOR 3.051850e-05

#ifndef CRITICAL_POINTS_MAX
#define CRITICAL_POINTS_MAX 100000
#endif

#ifndef ENDPOINTS_MAX
#define ENDPOINTS_MAX 10000
#endif

typedef float energytype;


// system include files

#include <fstream.h>
#include <iostream.h>
#include <stdlib.h>        // for malloc()
#include <stdio.h>
#include <math.h>

// isip include files

// #include <math/integral/integral.h>

// local include files


struct parameter_data 
{
  float number_of_channels, sample_type, channel_to_be_processed;
  float sample_frequency, frame_duration, window_duration;
  float nominal_noise_level, nominal_signal_level, noise_adaptation_constant;
  float signal_adaptation_constant;
  float nominal_noise_constant, nominal_signal_constant;
  float noise_adaptation_delta, signal_adaptation_delta, utterance_delta;
  float signal_adaptation_threshold, minimum_utterance_duration;
  float minimum_utterance_separation;
  float initial_padtime, final_padtime;
  int debug_level;
  float noise_floor;
  float zero_crossing_threshold;
};

struct critical_points_struct
{
  float time;
  bool positive_slope;
};

struct endpoints_struct
{
  float start_time;
  float end_time;
};


