// file: histogram.cc

#include "endpointer.h"


// main function

void histogram(float *energy_array, int size_of_energy_array, float max_energy, struct parameter_data *parameter)
{
  
  // variable declarations

  float histogram[100];
  int counter = 0;
  int non_zero_energy_values = 0;
  float level;

  // initialize all histogram values to zero

  while (counter < 100 )
    {
      histogram[counter] = 0;
      counter ++;
    }

  // compute histogram

  counter = 0 ;
  while (counter < (size_of_energy_array))
    {
      histogram[(int)(*energy_array + 99 )] ++;
       energy_array ++;
      counter ++;
    }

// delete all energy values below noise floor

  for(counter=0;counter < (100 + (int)parameter->noise_floor);counter++)
      histogram[counter] = 0;

// count valid energy values

  counter = 0;
  while (counter <100)
    {
      non_zero_energy_values += (int)histogram[counter];
      counter ++;
    }

  // normalize histogram

  counter = 0;
  while (counter < 100)
    {
      histogram[counter] = histogram[counter] / non_zero_energy_values;
      counter ++;
    }

  // debugging stuff - outputs histogram
  //
  counter = 0;
  while (counter < 100)
    {
      printf("%d %f\n", counter -99, histogram[counter]);
      counter ++;
    }

  // calculate nominal_noise_level and nominal_signal_level
  //
  printf("nominal_noise_constant = %5.2f\n", parameter->nominal_noise_constant);
  printf("nominal_signal_constant = %5.2f\n", parameter->nominal_signal_constant);

  counter = 0;
  level = 0;
  while (level < parameter->nominal_noise_constant)
    {
      level += histogram[counter];
      counter ++;
    }
  parameter->nominal_noise_level = counter - 99;
  while (level < parameter->nominal_signal_constant)
    {
      level += histogram[counter];
      counter ++;
    }
  parameter->nominal_signal_level = counter -99;

  printf("nominal_noise_level = %f\n" ,parameter->nominal_noise_level);
  printf("nominal_signal_level = %f\n", parameter->nominal_signal_level);

  return;

}
  
