// file: $JEIDA/src/signal_detector/v2.1/src/sigd_get_1.cc
//

// isip include files
//
#include "signal_detector.h"
#include "signal_detector_constants.h"

// method: get_endpoints_cc
//
// arguments:
//  float_4& t1_p: (output) start time of the utterance
//  float_4& t2_p: (output) end time of the utterance
//
// return:
//  a logical_1 value indicating the status:
//   if the return value is ISIP_FALSE, there are no active endpoints
//
logical_1 Signal_detector::get_endpoints_cc(float_4& t1_p, float_4& t2_p) {

  // check if valid endpoints exist
  //
  if (utt_beg_d < (int_4)0)
    {return ISIP_FALSE;}

  // convert the endpoints to time
  //
  t1_p = utt_beg_d * frame_dur_d;
  t2_p = utt_end_d * frame_dur_d;

  // exit gracefully
  //
  return ISIP_TRUE;
}
