// file: $JEIDA/src/signal_detector/v2.1/src/sigdp_cb_2.cc
//

// isip include files
//
#include "signal_detector.h"
#include "signal_detector_constants.h"

// method: cb_dump_cc
//
// arguments:
//  FILE* fp_p: file pointer to output the debug information to
//  char_1* message_p: a message to be concatenated to each debug message
//
// return:
//  a logical_1 indicating the status
//
logical_1 Signal_detector::cb_dump_cc(FILE* fp_p, char_1* message_p) {

  // dump a message
  //
  fprintf(fp_p, "%s\n", message_p);

  // loop over all unreleased data
  //
  int_4 nf = cur_frm_d;
  
  while (nf != rlse_frm_d) {
    fprintf(fp_p, "%ld (%ld):  %ld\n", nf, nf_d, cb_d[nf]);
    nf = cb_increment_cc(nf, (int_4)-1);
  }
  fprintf(fp_p, "%ld (%ld):  %ld\n", nf, nf_d, cb_d[nf]);

  // exit gracefully
  //
  return ISIP_TRUE;
}
