# file: $JEIDA/src/validate/v1.0/src/globals.tcl
#
# This file has sets many global variables that are used constantly
# in different parts of the program and initializes other variables
#
global maxcolnum column_separator blank_separator
global p
global transcription_date
global transcriber
global transcription
global comments
global old_transcription
global old_comments
global read_word_list_flag
global full_wordlist
global maxrownum
global width_of_plot
global height_of_plot
global plot_signal_program
global label_transcription_saved label_transcription_edited
global default_audio_command
global tmp_file_name
global env
global wordlist_directory
global utterances_in_set
global speaker_number
global utterance_number
global set_number
global out_file_format
global output_directory

# set the maximum number of columns and rows for the wordlist listboxes
#
set maxcolnum 5
set maxrownum 19

# width of frame is 246 + (146 * maxcolnum)
#
set width_of_plot [expr 230 + (146 * $maxcolnum)]
set height_of_plot 200

# set the constants that are recognized as special entries in the
# wordlist files
#
set column_separator "<next_column>"
set blank_separator "<blank_line>"

# set the name and information for the main toplevel
#
set p .top
set validator_title "JEIDA Validator"

# initialize variables
#
set read_word_list_flag 0
set full_wordlist ""
set transcription_date ""
set transcriber ""
set transcription ""
set comments ""
set old_transcription ""
set old_comments ""

# set the text for the visible astrick for the save flag
#
set label_transcription_edited "*Enter Transcription:"
set label_transcription_saved " Enter Transcription:"

# set the name and path of the plot_signal program
#
set plot_signal_program \
	"$env(JEIDA)/src/plot_signal/v1.0/src/plot_signal_tcl.exe" 


# set the default audio command
#
set default_audio_command naplay

# set the temporary file name
#
set proc_id [pid]
set tmp_file_name "/tmp/validator.$proc_id.tmp"

# set the directory for the wordlists
#
set wordlist_directory "/src/validate/v1.0/wordlists/"

# end of file
